/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#ifndef __TK_EXP_FLASH_TOGGLE_TOOL_H__
#define __TK_EXP_FLASH_TOGGLE_TOOL_H__

#include <gtkmm.h>

namespace TkResolver {
  namespace Experimenter {

    class FlashToggleTool : public Gtk::ToggleToolButton
      {
      private:
	/*	Gtk::Image *              _image;
	Glib::RefPtr<Gdk::Pixbuf> _normal_icon;
	Glib::RefPtr<Gdk::Pixbuf> _flash_icon;*/
	
	Gtk::Image                _normal_icon;
	Gtk::Image                _flash_icon;

	sigc::connection          _flash_signal;
	bool                      _on;
	
	bool signal();
	void on();
	void off();
      public:
	FlashToggleTool(const Gtk::StockID &stock_id,
			const Gtk::IconSize &icon_size,
			const Gdk::Color& flash_colour);
	
	void flash_start(unsigned long interval);
	void flash_stop();
      };
      
  } /* namespace Experimenter */
}; /* namespace TkResolver */




#endif /* __TK_EXP_FLASH_TOGGLE_TOOL_H__ */
