/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#include <boost/assign/list_of.hpp>

#include "intent_selector.h"

using namespace TkResolver;
using namespace Experimenter;
using namespace Db::Ui;

const static NameList code_columns = boost::assign::list_of(Name("code"));
const static NameList intent_columns = boost::assign::list_of(Name("description"));
const static ListColumnList display_columns = boost::assign::list_of
  (ListColumnInfo(Name("Code"), code_columns, 0))
  (ListColumnInfo(Name("Intent"), intent_columns, 0));

static Db::Name
table_sql(const Db::Id & experiment_group)
{
  TkString sql;
  sql  = TkString("(select   eio.*");
  sql += TkString(" from     experiment_group eg");
  sql += TkString(" ,        experiment_intent_option eio");
  sql += TkString(" where    eg.experiment_group_id = ");
  sql += TkString(experiment_group);
  sql += TkString(" and      eio.experiment_intent_id = eg.experiment_intent_id )");

  return Db::Name(sql);
}


IntentSelector:: IntentSelector(Db::Database * database,
				const Db::Id & experiment_group,
				const Db::Code & dflt)
  : DataSelectorList (database,
		      table_sql(experiment_group),
		      code_columns,
		      "Intent"),
    _default(dflt)
{
  set_display_columns(display_columns);
  set_selection("code", static_cast<TkString>(dflt));
}

/*void
IntentSelector:: set_selection(const Db::Code &selection) {
  for (Gtk::TreeModel::iterator iter( get_store()->get_iter("0") );
       iter;
       ++iter)
    {
      if (static_cast<Db::Code>(get_column_value(iter, "description")) == selection) {
	get_view().get_selection()->select(iter);
	break;
      }
    }
    }*/

Db::Code
IntentSelector:: get_intent_code() const
{
  return std::string(get_selection().front()["code"]);
}

void
IntentSelector:: refreshed()
{
  //  for (Gtk::TreeModel::iterator iter( get_store().
  //  get_view().get_selection()->select(Gtk::TreePath("0"));
}
