/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#ifndef __TK_EXP_LOCATION_SELECTOR_H__
#define __TK_EXP_LOCATION_SELECTOR_H__

#include <gtkmm.h>

#include "libtkcommon/tkstring.h"
#include "libtkdbui/data_selector_input_list.h"

namespace TkResolver {
  namespace Experimenter {
    
    class LocationInput : public Db::Ui::DataInput
      {
      private:
	Gtk::Entry      _name;
	Gtk::Entry      _address;
	Gtk::SpinButton _height;
      protected:
	virtual Db::Parameters * get_data_sub();
      public:
	LocationInput(Gtk::Window & parent);
      };

    class LocationSelector : public Db::Ui::DataSelectorInputList<LocationInput>
      {
      public:
	LocationSelector(Db::Database * database,
			 Gtk::Window * parent);
	TkString get_name() const;
      };
    
  } /* namespace Experimenter */
}; /* namespace TkResolver */

#endif /* __TK_EXP_LOCATION_SELECTOR_H__ */
