/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#include "libtkcommon/debug.h"
#include "libtkrandom/retriever_registry.h"
#include "randomness_source.h"

using namespace TkResolver;
using namespace Random;
using namespace Experimenter;

RandomnessSource:: RandomnessSource()
  : _sources(RetrieverRegistry::get_names())
{
  for (TkStringList::const_iterator iter = _sources.begin();
       iter != _sources.end();
       ++iter)
    {
      append_text(wstring_to_ustring(*iter));
    }
  
  for (TkStringList::const_iterator iter = _sources.begin();
       iter != _sources.end();
       ++iter)
    {
      if (RetrieverRegistry::is_true_randomness(*iter))
	{
	  set_active_text(wstring_to_ustring(*iter));
	  break;
	}
    }
  
  if (!get_active())
    {
      set_active(0);
    }
  
  _default = get_active_text();
}

void
RandomnessSource:: get_randomness_source(TkString & source,
					 bool & specified) const
{ 
  source = get_active_text();
  specified = (source != _default);
}
