/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#ifndef __TK_PAIR_H__
#define __TK_PAIR_H__

#include <utility>

#include <stdint.h>

namespace TkResolver {

  typedef uint8_t PairIndex;

  template <typename T>
    class Pair : public std::pair<T, T>
    {
    public:
      Pair() {}
      Pair(const T &first, const T &second)
	: std::pair<T, T> (first, second) {}
      
      T& operator[] (PairIndex index)
	{ return index ? std::pair<T, T>::first : std::pair<T, T>::second; }
      const T& operator[] (PairIndex index) const
	{ return index ? std::pair<T, T>::first : std::pair<T, T>::second; }
      
      T& get(PairIndex index)
	{ return (*this)[index]; }
      const T& get(PairIndex index) const
	{ return (*this)[index]; }
    };

}; /* namespace TkResolver */


#endif /* __TK_PAIR_H__ */
