/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#include "data_selector_combo.h"

using namespace TkResolver;
using namespace Db::Ui;

DataSelectorCombo:: DataSelectorCombo (Db::Database * database,
				       const Name & table_name,
				       const NameList & selection_columns)
  : DataSelector(database, table_name, selection_columns)
{
}

void
DataSelectorCombo:: set_display_columns(const ComboColumnList & display_columns)
{
  set_columns(display_column_names(display_columns));

  const Glib::RefPtr<Gtk::ListStore> & store(get_store());
  set_model(store);

  for (ComboColumnList::const_iterator iter(display_columns.begin());
       iter != display_columns.end();
       ++iter)
    {
      ComboColumnAdaptor adaptor(this);
      create_view_cell(*iter, adaptor);
    }

  show_all_children();

  set_active(store->get_iter(Gtk::TreePath("0")));
}


ModelIteratorList
DataSelectorCombo:: get_selected() const
{
  if (get_active_row_number() == -1)
    throw NoSelection();
  
  ModelIteratorList list;
  list.push_back(get_active());
  return list;
}

void
DataSelectorCombo:: refreshed()
{
  0;
}

void
DataSelectorCombo:: select(Gtk::TreeModel::iterator &iter)
{
  set_active(iter);
}
