/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#ifndef __TK_DB_UI_DATA_SELECTOR_INPUT_LIST_H__
#define __TK_DB_UI_DATA_SELECTOR_INPUT_LIST_H__

#include <gtkmm.h>

#include "data_selector_list.h"

namespace TkResolver {
  namespace Db {
    namespace Ui {

      class DataInput : public Gtk::Dialog
	{
	protected:
	  DataInput(const Glib::ustring & title, Gtk::Window & parent);
	  virtual Db::Parameters * get_data_sub() = 0;
	public:
	  Db::Parameters * get_data();
	};
      
      template<typename DI> class DataSelectorInputList : public DataSelectorList
	{
	private:
	  Gtk::Window *                         _parent;
	  void input();
	protected:
	  
	  DataSelectorInputList(Db::Database * database,
				const Name & table_name,
				const NameList & selection_columns,
				Gtk::Window * parent,
				const Name & title);
	  
	  virtual void refreshed();
	};

      #include "data_selector_input_list_impl.h"
      
    } /* namespace Ui */
  } /* namespace Db */
}; /* namespace TkResolver */




#endif /* __TK_DB_UI_DATA_SELECTOR_INPUT_LIST_H__ */
