/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

template<typename DI>
DataSelectorInputList<DI>:: DataSelectorInputList(Db::Database * database,
						  const Name & table_name,
						  const NameList & selection_columns,
						  Gtk::Window * parent,
						  const Name & title)
  : DataSelectorList (database,
		      table_name,
		      selection_columns,
		      title),
     _parent(parent)
{
  //
  // Control buttons
  //
  Gtk::VButtonBox * buttons = Gtk::manage(new Gtk::VButtonBox(Gtk::BUTTONBOX_START));
  get_box().pack_start(*buttons, false, true);
  
  Gtk::Button * button = Gtk::manage(new Gtk::Button(Gtk::Stock::ADD));
  button->set_focus_on_click(false);
  button->signal_clicked().connect( sigc::mem_fun(*this, &DataSelectorInputList<DI>::input) );
  buttons->pack_start(*button, true, true); 
}

template<typename DI>
void
DataSelectorInputList<DI>:: input()
{
  DataInput * di = new DI(*_parent);

  Db::Parameters * parameters(di->get_data());
  delete di;

  if (!parameters)
    return;

  get_database()->insert_table_data(get_table_name(), *parameters);
  delete parameters;

  refresh();
}

template<typename DI>
void
DataSelectorInputList<DI>:: refreshed()
{
  
}
