/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#ifndef __TK_ALEA_H__
#define __TK_ALEA_H__

#include <usb.h>

#include "randomness.h"
#include "retriever_registry.h"

namespace TkResolver {

  namespace Random {

    class Alea : public Retriever
    {
    private:
      static struct usb_dev_handle * _handle;
      static pthread_mutex_t         _alea_lock;

      void init_static ();
      
    public:
      Alea (unsigned chars);
      virtual Buffer * retrieve ();
    };

    class AleaType : public RetrieverType
    {
    public:
      virtual bool is_true_randomness();
      virtual unsigned get_preferred_block_size();
      virtual Retriever * new_retriever(unsigned count);
    };
  };
  
};


#endif /* __TK_ALEA_H__ */
