/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#include <iostream>

#include <stdlib.h>

#include "libtkcommon/exceptions.h"
#include "libtkcommon/debug.h"
#include "libtkcommon/real_time.h"
#include "retriever.h"

using namespace TkResolver;
using namespace Random;

Retriever:: Retriever(unsigned count)
  : _count(count),
    _thread(0),
    _buffer(0)
{
  if(!Glib::thread_supported())
    Glib::thread_init();
}

void
Retriever:: start()
{
  _thread = Glib::Thread::create(sigc::mem_fun(*this, &Retriever::run), true);
}

void
Retriever:: run()
{
  thread_set_real_time(40);
  
  _buffer = retrieve();
}

Buffer *
Retriever:: join()
{
  _thread->join();
  return _buffer;
}


unsigned &
Retriever:: get_count()
{
  return _count;
}

